import { Component } from 'react';
import { Instance } from 'tippy.js';
import type { LTWHP } from '../types';
interface State {
    height: number;
    width: number;
    html: string;
}
interface Props {
    children: JSX.Element | null;
    style: {
        top: number;
        left: number;
        bottom: number;
    };
    scrollTop: number;
    pageBoundingRect: LTWHP;
}
declare class TipContainer extends Component<Props, State> {
    state: State;
    node: HTMLDivElement | null;
    target: HTMLDivElement;
    tippy: Instance | null;
    renderedElement: HTMLDivElement;
    componentDidUpdate(nextProps: Props): void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    updatePosition: () => void;
    render(): JSX.Element | null;
}
export default TipContainer;
