"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@mantine/core");
const react_1 = __importStar(require("react"));
const react_dom_1 = __importDefault(require("react-dom"));
const tippy_js_1 = __importDefault(require("tippy.js"));
// const clamp = (value: number, left: number, right: number) =>
//   Math.min(Math.max(value, left), right)
class TipContainer extends react_1.Component {
    constructor() {
        super(...arguments);
        this.state = {
            height: 0,
            width: 0,
            html: ''
        };
        this.node = null;
        this.tippy = null;
        this.updatePosition = () => {
            if (!this.node) {
                return;
            }
            const { offsetHeight, offsetWidth } = this.node;
            this.setState({
                height: offsetHeight,
                width: offsetWidth
            });
        };
    }
    componentDidUpdate(nextProps) {
        console.log(nextProps);
        if (this.props.children !== nextProps.children) {
            this.updatePosition();
        }
    }
    componentDidMount() {
        if (!this.renderedElement) {
            const renderedElement = document.createElement('div');
            this.renderedElement = renderedElement;
        }
        if (!this.target) {
            const target = document.createElement('div');
            document.querySelector('.PdfHighlighter').appendChild(target);
            this.target = target;
        }
        react_dom_1.default.render(react_1.default.createElement(react_1.default.Fragment, null, this.props.children), this.renderedElement);
        this.forceUpdate();
        setTimeout(this.updatePosition, 0);
        // document.querySelector('.PdfHighlighter').addEventListener('scroll', () => {
        //   this.tippy[0].destroy()
        // })
    }
    componentWillUnmount() {
        // this.renderedElement?.remove()
        // this.target?.remove()
        // this.tippy?.destroy()
    }
    render() {
        if (!this.renderedElement) {
            return null;
        }
        const { children, style } = this.props;
        const { height, width } = this.state;
        const isStyleCalculationInProgress = width === 0 && height === 0;
        const left = style.left - width / 2;
        if (children) {
            const target = this.target;
            target.style.top = style.top + 'px';
            target.style.position = 'absolute';
            target.style.left = style.left + 'px';
            // @ts-ignore
            this.tippy = (0, tippy_js_1.default)(target, {
                theme: 'light',
                getReferenceClientRect: () => target.getBoundingClientRect(),
                appendTo: () => document.querySelector('.PdfHighlighter'),
                content: this.renderedElement.innerHTML,
                showOnCreate: true,
                allowHTML: true,
                interactive: true,
                trigger: 'manual',
                placement: 'bottom',
                onClickOutside: () => {
                    var _a;
                    (_a = this.tippy) === null || _a === void 0 ? void 0 : _a.hide();
                    setTimeout(() => {
                        var _a, _b, _c;
                        (_a = this.renderedElement) === null || _a === void 0 ? void 0 : _a.remove();
                        (_b = this.target) === null || _b === void 0 ? void 0 : _b.remove();
                        (_c = this.tippy) === null || _c === void 0 ? void 0 : _c.destroy();
                    }, 500);
                }
            });
        }
        else {
            return (react_1.default.createElement("div", { className: "PdfHighlighter__tip-container", style: {
                    visibility: isStyleCalculationInProgress ? 'hidden' : 'visible',
                    top: style.top,
                    left
                }, ref: (node) => {
                    this.node = node;
                } },
                react_1.default.createElement(react_1.default.Fragment, null,
                    react_1.default.createElement(core_1.Stack, { sx: { opacity: '0', filter: 'alpha(opacity=0)' } },
                        react_1.default.createElement("textarea", { autoFocus: true, ref: (node) => {
                                setTimeout(() => {
                                    node === null || node === void 0 ? void 0 : node.focus();
                                }, 50);
                            } })))));
        }
        return react_1.default.createElement(react_1.default.Fragment, null);
    }
}
exports.default = TipContainer;
//# sourceMappingURL=TipContainer.js.map